#!/usr/bin/env python
# Written by Kevin Cole <kjcole@ubuntu.com> 2011.01.26
# A demo for the first part of GASP Lesson 3
#

from gasp import *
from math import radians,degrees,sin,cos
begin_graphics()

grid  = []

def grid_on(shade):
    """Draw a grid on keypress"""
    global grid
    for x in range(260,530,30):
        grid.append(Line((x,160), (x,400), color=shade))
        grid.append(Text(str(x),(x-12,140)))
    for y in range(160,430,30):
        grid.append(Line((260,y), (500,y), color=shade))
        grid.append(Text(str(y),(230,y-6)))
    update_when('key_pressed')

def grid_off():
    """Erase grid on keypress"""
    global grid
    for lines in grid:
        remove_from_screen(lines)
    update_when('key_pressed')
    del grid[:]

def compass(shade):
    """Animate a 'compass' to illustrate drawing a circle"""
    sweep = []
#   dot = Plot((380,280))
    update_when('key_pressed')
    arm = Line((380,280),(500,280),color=shade)
    for deg in range(0,361):
        rad = radians(deg)
        x2,y2 = (int(cos(rad)*120))+380,(int(sin(rad)*120))+280
        remove_from_screen(arm)
        arm = Line((380,280),(x2,y2),color=shade)
        sweep.append(Arc((380,280), 120, deg,deg+1,color=shade))
        sleep(0.02)
    update_when('key_pressed')
    remove_from_screen(arm)
#   remove_from_screen(dot)

grid_on(color.LIGHTGRAY)
grid_off()
compass(color.LIGHTGRAY)
grid_on(color.LIGHTGRAY)

head        = Circle((380,280),120)
update_when('key_pressed')

left_eye    = Circle((335,310), 15)
update_when('key_pressed')

right_eye   = Circle((425,310), 15)
update_when('key_pressed')

nose_base   = Line((350,250), (410,250))
update_when('key_pressed')

nose_bridge = Line((350,250), (380,310))
update_when('key_pressed')

guide = Circle((380,280),90,color=color.LIGHTGRAY) # Full circle for arc
update_when('key_pressed')
wide =  Arc((380,280), 90, 210,330, thickness=2)   # Overlay with thick arc
update_when('key_pressed')
remove_from_screen(guide)                          # Remove guide circle
remove_from_screen(wide)                           # Remove thick arc

mouth = Arc((380,280), 90, 210,330, thickness=1)
update_when('key_pressed')
grid_off()

end_graphics()
