from gasp import *

SCREEN_WIDTH = 800
SCREEN_HEIGHT = 600
GAME_WIDTH = 800
GAME_HEIGHT = 600
GRID_SIZE = 20
keys = ['up','down','left','right']
finished = False
score = 0
status = ""

class Game_begin:
    def __init__(self):
        center = (SCREEN_WIDTH/2, SCREEN_HEIGHT/2)
        a = Text("Welcome to Snake",
                 (center[0]-187, center[1]+58),
                 size=50)
        sleep(3)
        remove_from_screen(a)
            

class Head:
  
    def __init__(self):
        self.x = ((GAME_WIDTH/GRID_SIZE)/2)* GRID_SIZE
        self.y = ((GAME_HEIGHT/GRID_SIZE)/2)* GRID_SIZE
        self.image = Box((self.x, self.y), GRID_SIZE, GRID_SIZE)
        self.current = 'up'
    def move(self):
        if self.current == 'up':
            move_up(self)
        if self.current == 'down':
            move_down(self)
        if self.current == 'left':
            move_left(self)
        if self.current == 'right':
            move_right(self)

class Body:
    def __init__(self, head):
        self.parts =[ [Box((head.x, head.y),
                            head.x+GRID_SIZE,
                            head.y+GRID_SIZE,
                            color=color.BLUE),
                            head.x,
                            head.y],
                       [Box((head.x, head.y),
                            head.x+GRID_SIZE,
                            head.y+GRID_SIZE,
                            color=color.BLUE),
                            head.x,
                            head.y]
                       ]


class Tail:
    def __init__(self):
        self.x = ((GAME_WIDTH/10)/2)* GRID_SIZE
        self.y = ((GAME_HEIGHT/10)/2)* GRID_SIZE - 2 * GRID_SIZE
        self.image = Box((self.x, self.y),
                         self.x+GRID_SIZE,
                         self.y+GRID_SIZE,
                         color=color.GREEN)


class Snake(Head, Body, Tail):
    def __init__(self):
        self.head = Head()
        self.body = Body(self.head)
        
        self.tail = Tail()
        self.current = 'up'
        self.speed = .01
        self.status = 'still going'

    def add_money(self):
        money = Money()
        
    def move(self):
        body = self.body.parts
        
        self.tail.x = body[0][1]
        self.tail.y = body[0][2]
        # move the tail to where the back of the body is
        move_to(self.tail.image, (self.tail.x, self.tail.y))
        
        body[0][1] = self.head.x
        body[0][2]= self.head.y
        # move the back of the body to where the head is 
        move_to(body[0][0], (body[0][1], body[0][2]))
        
        self.head.move() # move head

        new_body = []
        back = body[0]
        new_body = body[1:]
        new_body.append(body[0])
        self.body.parts = new_body # update body

    def check_status(self):
        #if self.head.y == SCREEN_HEIGHT:    #check if snake has hit the edges
        #    self.status = "lose"
        #if self.head.y < 0:
        #    self.status = "lose"
        #if self.head.x < 0:
        #    self.status = "lose"
        #if self.head.x == SCREEN_WIDTH:
        #    self.status = "lose"
            
        if self.head.x == self.tail.x and self.head.y == self.tail.y: #check if the snake hits its tail
            self.status = "lose"
            
        checked_bodies = self.body.parts[:-1]   #check if the snake hits it's body
        for bodies in checked_bodies:
            if bodies[1] == self.head.x and bodies[2] == self.head.y:
                self.status = "lose"
    
    def add_body(self, head):
        self.body.parts.append([Box((head.x, head.y),
                                    head.x+GRID_SIZE,
                                    head.y+GRID_SIZE,
                                    color=color.BLUE),
                                    head.x,
                                    head.y])
        
class Money:
    def __init__(self, grid):
        self.pos = random.choice(grid.possible)
        self.x = self.pos[0]
        self.y = self.pos[1]
        #self.image = image("money.jpeg", self.x, self.y, 50, 50)
        self.image = Box((self.x, self.y),
                         self.x+GRID_SIZE,
                         self.y+GRID_SIZE,
                         color.RED)
        self.collected = 0
        self.score = Score()
        print "the money is at","(",self.x,",",self.y,")"



class Grid:
    def __init__(self):
        self.possible = []
        for y in range(0, GAME_HEIGHT, GRID_SIZE):
            for x in range(0, GAME_WIDTH, GRID_SIZE):
                self.possible.append((x, y))
        
class Score:
    def __init__(self):
        self.number = 0
        self.text = Text("Score = %i" % self.number,
                         (5, 0),
                         color.BLACK,
                         30)
        print self.number

    def add(self):
        self.number += 1
        remove_from_screen(self.text)
        self.text = text("Score = %i" %self.number, 5, 0, 30)

def check_coll(snake, money, grid):
    if snake.head.x == money.x and snake.head.y == money.y:
        money.collected += 1
        money.score.add()
        print money.score.number
        money.pos = random.choice(grid.possible)
        money.x = money.pos[0]
        money.y = money.pos[1]
        move_to(money.image, (money.x, money.y))
        snake.add_body(snake.head)


def move_up(obj):
    if obj.y >= GAME_HEIGHT:
        obj.y = 0
        move_to(obj.image, (obj.x, obj.y))
    move_by(obj.image, 0, GRID_SIZE)
    obj.y += GRID_SIZE


def move_down(obj):
    if obj.y <= 0:
        obj.y = GAME_HEIGHT
        move_to(obj.image, obj.x, obj.y)
    move_by(obj.image, 0, -GRID_SIZE)
    obj.y -= GRID_SIZE


def move_left(obj):
    if obj.x <= 0:
        obj.x = GAME_WIDTH
        move_to(obj.image, obj.x, obj.y)
    move_by(obj.image, -GRID_SIZE, 0)
    obj.x -= GRID_SIZE

def move_right(obj):
    if obj.x >= GAME_WIDTH:
        obj.x = 0 
        move_to(obj.image, obj.x, obj.y)
    move_by(obj.image, dx=GRID_SIZE)
    obj.x += GRID_SIZE
     
def play():
    begin_graphics(SCREEN_WIDTH,
                   SCREEN_HEIGHT,
                   title='Snake!',
                   background=color.DARKGRAY)
    set_speed(120)
    Game_begin()
    grid = Grid()
    snake = Snake()
    money = Money(grid)

    while finished == False:
        if 'escape' in keys_pressed():
            break
        if snake.status == "lose":
            break
        for index in range(0,4):  #This changes the snakes direction
            if keys[index] in keys_pressed():
                snake.head.current = keys[index]
        snake.move()
        check_coll(snake, money, grid)
        snake.check_status()
        update_when('next_tick')

    if snake.status == "lose":
        print "You are a loser, and your score is %i" % money.collected

play()
